Hex Artifact Content

Artifact 31c808db14dbb583f3998862e79b1adc522dede9:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 43 6c 65 61 6e 20 76 61  bash..# Clean va
0020: 72 69 61 62 6c 65 73 20 77 68 69 63 68 20 77 69  riables which wi
0030: 6c 6c 20 69 6e 74 65 72 66 65 72 65 20 77 69 74  ll interfere wit
0040: 68 20 74 68 65 20 62 75 69 6c 64 0a 75 6e 73 65  h the build.unse
0050: 74 20 4d 41 4b 45 46 4c 41 47 53 20 44 45 53 54  t MAKEFLAGS DEST
0060: 44 49 52 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65  DIR..# Determine
0070: 20 61 70 70 72 6f 70 72 69 61 74 65 20 6d 6f 64   appropriate mod
0080: 65 0a 6d 6f 64 65 3d 22 62 75 69 6c 64 22 0a 63  e.mode="build".c
0090: 61 73 65 20 22 24 31 22 20 69 6e 0a 09 63 6c 65  ase "$1" in..cle
00a0: 61 6e 7c 64 69 73 74 63 6c 65 61 6e 7c 62 75 69  an|distclean|bui
00b0: 6c 64 7c 72 65 74 72 79 29 0a 09 09 6d 6f 64 65  ld|retry)...mode
00c0: 3d 22 24 31 22 0a 09 09 73 68 69 66 74 0a 09 09  ="$1"...shift...
00d0: 3b 3b 0a 65 73 61 63 0a 0a 23 20 44 65 74 65 72  ;;.esac..# Deter
00e0: 6d 69 6e 65 20 77 68 69 63 68 20 54 63 6c 20 76  mine which Tcl v
00f0: 65 72 73 69 6f 6e 20 74 6f 20 62 75 69 6c 64 0a  ersion to build.
0100: 54 43 4c 56 45 52 53 3d 22 38 2e 36 2e 37 22 0a  TCLVERS="8.6.7".
0110: 69 66 20 65 63 68 6f 20 22 24 31 22 20 7c 20 67  if echo "$1" | g
0120: 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d  rep '^[0-9][0-9]
0130: 2a 5c 2e 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  *\.' >/dev/null 
0140: 7c 7c 20 65 63 68 6f 20 22 24 31 22 20 7c 20 65  || echo "$1" | e
0150: 67 72 65 70 20 27 5e 28 63 76 73 7c 66 6f 73 73  grep '^(cvs|foss
0160: 69 6c 29 5f 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  il)_' >/dev/null
0170: 3b 20 74 68 65 6e 0a 09 54 43 4c 56 45 52 53 3d  ; then..TCLVERS=
0180: 22 24 31 22 0a 0a 09 73 68 69 66 74 0a 66 69 0a  "$1"...shift.fi.
0190: 65 78 70 6f 72 74 20 54 43 4c 56 45 52 53 0a 0a  export TCLVERS..
01a0: 23 20 41 64 64 20 74 68 65 20 68 65 6c 70 65 72  # Add the helper
01b0: 73 20 64 69 72 65 63 74 6f 72 79 20 74 6f 20 74  s directory to t
01c0: 68 65 20 70 61 74 68 0a 50 41 54 48 3d 22 24 28  he path.PATH="$(
01d0: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
01e0: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
01f0: 26 26 20 70 77 64 29 22 2f 63 6f 6d 6d 6f 6e 2f  && pwd)"/common/
0200: 68 65 6c 70 65 72 73 3a 22 24 7b 50 41 54 48 7d  helpers:"${PATH}
0210: 22 0a 65 78 70 6f 72 74 20 50 41 54 48 0a 0a 23  ".export PATH..#
0220: 20 56 65 72 69 66 79 20 74 68 61 74 20 22 70 72   Verify that "pr
0230: 65 2e 73 68 22 20 68 61 73 20 62 65 65 6e 20 72  e.sh" has been r
0240: 75 6e 20 69 66 20 74 68 69 73 20 69 73 20 61 20  un if this is a 
0250: 64 65 76 65 6c 6f 70 6d 65 6e 74 20 73 6e 61 70  development snap
0260: 73 68 6f 74 20 6f 66 0a 23 20 4b 69 74 43 72 65  shot of.# KitCre
0270: 61 74 6f 72 0a 69 66 20 5b 20 2d 66 20 27 62 75  ator.if [ -f 'bu
0280: 69 6c 64 2f 70 72 65 2e 73 68 27 20 5d 3b 20 74  ild/pre.sh' ]; t
0290: 68 65 6e 0a 09 69 66 20 21 20 66 69 6e 64 20 27  hen..if ! find '
02a0: 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 2f 27  kitsh/buildsrc/'
02b0: 20 2d 6e 61 6d 65 20 63 6f 6e 66 69 67 75 72 65   -name configure
02c0: 20 2d 74 79 70 65 20 66 20 32 3e 2f 64 65 76 2f   -type f 2>/dev/
02d0: 6e 75 6c 6c 20 7c 20 67 72 65 70 20 63 6f 6e 66  null | grep conf
02e0: 69 67 75 72 65 20 3e 2f 64 65 76 2f 6e 75 6c 6c  igure >/dev/null
02f0: 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 50  ; then...echo "P
0300: 6c 65 61 73 65 20 72 65 6d 65 6d 62 65 72 20 74  lease remember t
0310: 6f 20 72 75 6e 20 27 62 75 69 6c 64 2f 70 72 65  o run 'build/pre
0320: 2e 73 68 27 20 69 66 20 79 6f 75 20 65 78 70 65  .sh' if you expe
0330: 63 74 20 74 68 69 73 20 62 75 69 6c 64 20 74 6f  ct this build to
0340: 20 77 6f 72 6b 2e 22 20 3e 26 32 0a 09 66 69 0a   work." >&2..fi.
0350: 66 69 0a 0a 23 20 44 65 66 69 6e 65 20 74 68 65  fi..# Define the
0360: 20 6c 69 73 74 20 6f 66 20 61 6c 6c 20 70 61 63   list of all pac
0370: 6b 61 67 65 73 2c 20 66 6f 72 20 63 6c 65 61 6e  kages, for clean
0380: 69 6e 67 20 70 75 72 70 6f 73 65 73 0a 4b 49 54  ing purposes.KIT
0390: 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53 3d  CREATOR_ALLPKGS=
03a0: 22 6b 69 74 73 68 20 74 63 6c 20 74 63 6c 76 66  "kitsh tcl tclvf
03b0: 73 20 7a 6c 69 62 20 74 6b 20 69 74 63 6c 20 6d  s zlib tk itcl m
03c0: 6b 34 74 63 6c 20 74 68 72 65 61 64 20 64 62 75  k4tcl thread dbu
03d0: 73 20 74 6c 73 20 74 63 6c 78 20 74 63 63 34 74  s tls tclx tcc4t
03e0: 63 6c 20 74 63 6c 6c 69 62 20 75 64 70 20 79 61  cl tcllib udp ya
03f0: 6a 6c 74 63 6c 20 74 64 6f 6d 20 74 75 61 70 69  jltcl tdom tuapi
0400: 22 0a 0a 23 20 41 6c 77 61 79 73 20 72 65 62 75  "..# Always rebu
0410: 69 6c 64 20 6b 69 74 73 68 0a 72 6d 20 2d 66 20  ild kitsh.rm -f 
0420: 22 6b 69 74 73 68 2f 2e 73 75 63 63 65 73 73 22  "kitsh/.success"
0430: 0a 66 6f 72 20 70 6b 67 20 69 6e 20 24 7b 4b 49  .for pkg in ${KI
0440: 54 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53  TCREATOR_ALLPKGS
0450: 7d 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50  } ${KITCREATOR_P
0460: 4b 47 53 7d 3b 20 64 6f 0a 09 69 66 20 5b 20 22  KGS}; do..if [ "
0470: 24 7b 6d 6f 64 65 7d 22 20 21 3d 20 22 72 65 74  ${mode}" != "ret
0480: 72 79 22 20 2d 6f 20 21 20 2d 66 20 22 24 7b 70  ry" -o ! -f "${p
0490: 6b 67 7d 2f 2e 73 75 63 63 65 73 73 22 20 5d 3b  kg}/.success" ];
04a0: 20 74 68 65 6e 0a 09 09 72 6d 20 2d 66 20 22 24   then...rm -f "$
04b0: 7b 70 6b 67 7d 2f 62 75 69 6c 64 2e 6c 6f 67 22  {pkg}/build.log"
04c0: 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73   "${pkg}/.succes
04d0: 73 22 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 70  s"...rm -rf "${p
04e0: 6b 67 7d 2f 6f 75 74 22 20 22 24 7b 70 6b 67 7d  kg}/out" "${pkg}
04f0: 2f 69 6e 73 74 22 20 22 24 7b 70 6b 67 7d 2f 62  /inst" "${pkg}/b
0500: 75 69 6c 64 22 0a 0a 09 09 72 6d 20 2d 72 66 20  uild"....rm -rf 
0510: 22 24 7b 70 6b 67 7d 2f 73 72 63 22 2f 74 6d 70  "${pkg}/src"/tmp
0520: 2d 2a 0a 09 66 69 0a 0a 09 69 66 20 5b 20 22 24  -*..fi...if [ "$
0530: 7b 6d 6f 64 65 7d 22 20 3d 20 22 64 69 73 74 63  {mode}" = "distc
0540: 6c 65 61 6e 22 20 5d 3b 20 74 68 65 6e 0a 09 09  lean" ]; then...
0550: 72 6d 20 2d 72 66 20 22 24 7b 70 6b 67 7d 2f 73  rm -rf "${pkg}/s
0560: 72 63 22 0a 09 66 69 0a 64 6f 6e 65 0a 0a 23 20  rc"..fi.done..# 
0570: 57 65 27 72 65 20 61 6c 6c 20 64 6f 6e 65 20 69  We're all done i
0580: 66 20 77 65 27 72 65 20 69 6e 20 63 6c 65 61 6e  f we're in clean
0590: 20 6f 72 20 64 69 73 74 63 6c 65 61 6e 20 6d 6f   or distclean mo
05a0: 64 65 0a 69 66 20 5b 20 22 24 7b 6d 6f 64 65 7d  de.if [ "${mode}
05b0: 22 20 3d 20 22 63 6c 65 61 6e 22 20 2d 6f 20 22  " = "clean" -o "
05c0: 24 7b 6d 6f 64 65 7d 22 20 3d 20 22 64 69 73 74  ${mode}" = "dist
05d0: 63 6c 65 61 6e 22 20 5d 3b 20 74 68 65 6e 0a 09  clean" ]; then..
05e0: 72 6d 20 2d 66 20 74 63 6c 6b 69 74 2d 2a 0a 09  rm -f tclkit-*..
05f0: 72 6d 20 2d 66 20 6c 69 62 74 63 6c 6b 69 74 2a  rm -f libtclkit*
0600: 2e 2a 0a 0a 09 65 78 69 74 20 30 0a 66 69 0a 0a  .*...exit 0.fi..
0610: 23 20 41 64 64 20 70 61 63 6b 61 67 65 73 20 69  # Add packages i
0620: 6d 70 6c 69 65 64 20 62 79 20 74 68 65 20 61 64  mplied by the ad
0630: 64 69 74 69 6f 6e 61 6c 20 61 72 67 75 6d 65 6e  ditional argumen
0640: 74 73 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 4b 49  ts.if [ -z "${KI
0650: 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 22 20  TCREATOR_PKGS}" 
0660: 5d 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52 45 41  ]; then..KITCREA
0670: 54 4f 52 5f 50 4b 47 53 3d 22 74 6b 20 69 74 63  TOR_PKGS="tk itc
0680: 6c 20 6d 6b 34 74 63 6c 22 0a 66 69 0a 0a 43 4f  l mk4tcl".fi..CO
0690: 4e 46 49 47 55 52 45 45 58 54 52 41 3d 22 24 40  NFIGUREEXTRA="$@
06a0: 22 0a 65 78 70 6f 72 74 20 43 4f 4e 46 49 47 55  ".export CONFIGU
06b0: 52 45 45 58 54 52 41 0a 0a 69 66 20 65 63 68 6f  REEXTRA..if echo
06c0: 20 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58   " ${CONFIGUREEX
06d0: 54 52 41 7d 20 22 20 7c 20 67 72 65 70 20 27 20  TRA} " | grep ' 
06e0: 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65 61 64 73  --enable-threads
06f0: 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e   ' >/dev/null 2>
0700: 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a  /dev/null; then.
0710: 09 4b 49 54 43 52 45 41 54 4f 52 5f 41 44 44 5f  .KITCREATOR_ADD_
0720: 45 4e 41 42 4c 45 5f 54 48 52 45 41 44 53 3d 27  ENABLE_THREADS='
0730: 31 27 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 50  1'..KITCREATOR_P
0740: 4b 47 53 3d 22 24 7b 4b 49 54 43 52 45 41 54 4f  KGS="${KITCREATO
0750: 52 5f 50 4b 47 53 7d 20 74 68 72 65 61 64 22 0a  R_PKGS} thread".
0760: 65 6c 69 66 20 65 63 68 6f 20 22 20 24 7b 43 4f  elif echo " ${CO
0770: 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20 22 20  NFIGUREEXTRA} " 
0780: 7c 20 67 72 65 70 20 27 20 2d 2d 64 69 73 61 62  | grep ' --disab
0790: 6c 65 2d 74 68 72 65 61 64 73 20 27 20 3e 2f 64  le-threads ' >/d
07a0: 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e  ev/null 2>/dev/n
07b0: 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52  ull; then..KITCR
07c0: 45 41 54 4f 52 5f 41 44 44 5f 45 4e 41 42 4c 45  EATOR_ADD_ENABLE
07d0: 5f 54 48 52 45 41 44 53 3d 27 30 27 0a 66 69 0a  _THREADS='0'.fi.
07e0: 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 63 72 6f  .# Determine cro
07f0: 73 73 2d 63 6f 6d 70 69 6c 65 20 73 74 61 74 75  ss-compile statu
0800: 73 0a 68 6f 73 74 5f 6f 73 3d 22 24 28 65 63 68  s.host_os="$(ech
0810: 6f 20 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45  o " ${CONFIGUREE
0820: 58 54 52 41 7d 20 22 20 7c 20 73 65 64 20 27 73  XTRA} " | sed 's
0830: 40 5e 2e 2a 20 2d 2d 68 6f 73 74 3d 5c 28 5b 5e  @^.* --host=\([^
0840: 20 5d 2a 5c 29 20 2e 2a 24 40 5c 31 40 0a 74 20   ]*\) .*$@\1@.t 
0850: 78 0a 64 0a 3a 78 27 29 22 0a 62 75 69 6c 64 5f  x.d.:x')".build_
0860: 6f 73 3d 22 24 28 65 63 68 6f 20 22 20 24 7b 43  os="$(echo " ${C
0870: 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20 22  ONFIGUREEXTRA} "
0880: 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 20 2d 2d   | sed 's@^.* --
0890: 62 75 69 6c 64 3d 5c 28 5b 5e 20 5d 2a 5c 29 20  build=\([^ ]*\) 
08a0: 2e 2a 24 40 5c 31 40 0a 74 20 78 0a 64 0a 3a 78  .*$@\1@.t x.d.:x
08b0: 27 29 22 0a 0a 69 66 20 5b 20 22 24 7b 68 6f 73  ')"..if [ "${hos
08c0: 74 5f 6f 73 7d 22 20 21 3d 20 22 24 7b 62 75 69  t_os}" != "${bui
08d0: 6c 64 5f 6f 73 7d 22 20 2d 61 20 2d 6e 20 22 24  ld_os}" -a -n "$
08e0: 7b 68 6f 73 74 5f 6f 73 7d 22 20 5d 3b 20 74 68  {host_os}" ]; th
08f0: 65 6e 0a 09 4b 43 5f 43 52 4f 53 53 43 4f 4d 50  en..KC_CROSSCOMP
0900: 49 4c 45 3d 27 31 27 0a 09 4b 43 5f 43 52 4f 53  ILE='1'..KC_CROS
0910: 53 43 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f 4f 53  SCOMPILE_HOST_OS
0920: 3d 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 0a 65 6c  ="${host_os}".el
0930: 73 65 0a 09 4b 43 5f 43 52 4f 53 53 43 4f 4d 50  se..KC_CROSSCOMP
0940: 49 4c 45 3d 27 30 27 0a 09 4b 43 5f 43 52 4f 53  ILE='0'..KC_CROS
0950: 53 43 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f 4f 53  SCOMPILE_HOST_OS
0960: 3d 27 27 0a 66 69 0a 65 78 70 6f 72 74 20 4b 43  =''.fi.export KC
0970: 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 20 4b 43  _CROSSCOMPILE KC
0980: 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 5f 48 4f  _CROSSCOMPILE_HO
0990: 53 54 5f 4f 53 0a 0a 23 20 53 65 74 20 64 65 66  ST_OS..# Set def
09a0: 61 75 6c 74 20 74 61 72 67 65 74 0a 4b 49 54 54  ault target.KITT
09b0: 41 52 47 45 54 3d 22 6b 69 74 73 68 22 0a 65 78  ARGET="kitsh".ex
09c0: 70 6f 72 74 20 4b 49 54 54 41 52 47 45 54 0a 0a  port KITTARGET..
09d0: 23 20 46 69 78 20 75 70 20 70 61 63 6b 61 67 65  # Fix up package
09e0: 20 6c 69 73 74 0a 23 23 20 49 66 20 62 75 69 6c   list.## If buil
09f0: 64 69 6e 67 20 4b 69 74 44 4c 4c 2c 20 64 65 66  ding KitDLL, def
0a00: 69 6e 65 20 69 74 20 61 73 20 6f 75 72 20 74 61  ine it as our ta
0a10: 72 67 65 74 0a 69 66 20 65 63 68 6f 20 22 20 24  rget.if echo " $
0a20: 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53  {KITCREATOR_PKGS
0a30: 7d 20 22 20 7c 20 67 72 65 70 20 27 20 6b 69 74  } " | grep ' kit
0a40: 64 6c 6c 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  dll ' >/dev/null
0a50: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68   2>/dev/null; th
0a60: 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 50  en..KITCREATOR_P
0a70: 4b 47 53 3d 22 24 28 65 63 68 6f 20 22 20 24 7b  KGS="$(echo " ${
0a80: 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d  KITCREATOR_PKGS}
0a90: 20 22 20 7c 20 73 65 64 20 27 73 40 20 6b 69 74   " | sed 's@ kit
0aa0: 64 6c 6c 20 40 20 40 67 3b 73 40 5e 20 20 2a 40  dll @ @g;s@^  *@
0ab0: 40 3b 73 40 20 20 2a 24 40 40 3b 73 40 20 20 20  @;s@  *$@@;s@   
0ac0: 2a 40 20 40 67 27 29 22 0a 09 4b 49 54 54 41 52  *@ @g')"..KITTAR
0ad0: 47 45 54 3d 22 6b 69 74 64 6c 6c 22 0a 66 69 0a  GET="kitdll".fi.
0ae0: 0a 23 20 49 66 20 74 68 65 20 75 73 65 72 20 6d  .# If the user m
0af0: 61 6e 75 61 6c 6c 79 20 72 65 71 75 65 73 74 65  anually requeste
0b00: 64 20 22 2d 2d 65 6e 61 62 6c 65 2d 6b 69 74 64  d "--enable-kitd
0b10: 6c 6c 22 2c 20 6d 61 6b 65 20 69 74 20 73 6f 0a  ll", make it so.
0b20: 69 66 20 65 63 68 6f 20 22 78 20 24 40 20 22 20  if echo "x $@ " 
0b30: 7c 20 67 72 65 70 20 27 20 5b 2d 5d 5b 2d 5d 65  | grep ' [-][-]e
0b40: 6e 61 62 6c 65 2d 6b 69 74 64 6c 6c 20 27 20 3e  nable-kitdll ' >
0b50: 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76  /dev/null 2>/dev
0b60: 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49 54  /null; then..KIT
0b70: 54 41 52 47 45 54 3d 22 6b 69 74 64 6c 6c 22 0a  TARGET="kitdll".
0b80: 66 69 0a 0a 23 23 20 49 66 20 62 75 69 6c 64 69  fi..## If buildi
0b90: 6e 67 20 4b 69 74 44 4c 4c 20 61 6e 64 20 54 6b  ng KitDLL and Tk
0ba0: 2c 20 6d 75 73 74 20 64 6f 20 54 6b 20 73 74 61  , must do Tk sta
0bb0: 74 69 63 61 6c 6c 79 0a 23 23 23 20 28 57 65 6c  tically.### (Wel
0bc0: 6c 2c 20 77 65 20 64 6f 6e 27 74 20 48 41 56 45  l, we don't HAVE
0bd0: 20 74 6f 2c 20 62 75 74 20 69 74 20 77 6f 75 6c   to, but it woul
0be0: 64 20 64 65 66 65 61 74 20 6d 75 63 68 20 6f 66  d defeat much of
0bf0: 20 74 68 65 20 70 75 72 70 6f 73 65 29 0a 69 66   the purpose).if
0c00: 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d   [ "${KITTARGET}
0c10: 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20  " = "kitdll" ]; 
0c20: 74 68 65 6e 0a 09 69 66 20 65 63 68 6f 20 22 20  then..if echo " 
0c30: 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47  ${KITCREATOR_PKG
0c40: 53 7d 20 22 20 7c 20 67 72 65 70 20 27 20 74 6b  S} " | grep ' tk
0c50: 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e   ' >/dev/null 2>
0c60: 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a  /dev/null; then.
0c70: 09 09 69 66 20 5b 20 22 24 7b 53 54 41 54 49 43  ..if [ "${STATIC
0c80: 54 4b 7d 22 20 21 3d 20 22 31 22 20 2d 61 20 22  TK}" != "1" -a "
0c90: 24 7b 53 54 41 54 49 43 54 4b 7d 22 20 21 3d 20  ${STATICTK}" != 
0ca0: 22 2d 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09  "-1" ]; then....
0cb0: 65 63 68 6f 20 27 57 61 72 6e 69 6e 67 3a 20 4c  echo 'Warning: L
0cc0: 69 6e 6b 69 6e 67 20 54 6b 20 73 74 61 74 69 63  inking Tk static
0cd0: 61 6c 6c 79 20 62 65 63 61 75 73 65 20 79 6f 75  ally because you
0ce0: 20 61 72 65 20 62 75 69 6c 64 69 6e 67 20 4b 69   are building Ki
0cf0: 74 44 4c 4c 27 20 32 3e 26 31 0a 09 09 09 65 63  tDLL' 2>&1....ec
0d00: 68 6f 20 27 20 20 20 20 20 20 20 20 20 53 65 74  ho '         Set
0d10: 20 53 54 41 54 49 43 54 4b 20 74 6f 20 2d 31 20   STATICTK to -1 
0d20: 69 66 20 79 6f 75 20 72 65 61 6c 6c 79 20 77 61  if you really wa
0d30: 6e 74 20 74 6f 20 6c 69 6e 6b 20 54 6b 20 64 79  nt to link Tk dy
0d40: 6e 61 6d 69 63 61 6c 6c 79 2e 27 20 3e 26 32 0a  namically.' >&2.
0d50: 0a 09 09 09 53 54 41 54 49 43 54 4b 3d 22 31 22  ....STATICTK="1"
0d60: 0a 09 09 09 65 78 70 6f 72 74 20 53 54 41 54 49  ....export STATI
0d70: 43 54 4b 0a 09 09 66 69 0a 09 66 69 0a 0a 09 69  CTK...fi..fi...i
0d80: 66 20 65 63 68 6f 20 22 20 24 7b 4b 49 54 43 52  f echo " ${KITCR
0d90: 45 41 54 4f 52 5f 50 4b 47 53 7d 20 22 20 7c 20  EATOR_PKGS} " | 
0da0: 67 72 65 70 20 27 20 6d 6b 34 74 63 6c 20 27 20  grep ' mk4tcl ' 
0db0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
0dc0: 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 69  v/null; then...i
0dd0: 66 20 5b 20 2d 7a 20 22 24 7b 53 54 41 54 49 43  f [ -z "${STATIC
0de0: 4d 4b 34 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  MK4}" ]; then...
0df0: 09 65 63 68 6f 20 27 57 61 72 6e 69 6e 67 3a 20  .echo 'Warning: 
0e00: 4c 69 6e 6b 69 6e 67 20 4d 6b 34 74 63 6c 20 64  Linking Mk4tcl d
0e10: 79 6e 61 6d 69 63 61 6c 6c 79 20 62 65 63 61 75  ynamically becau
0e20: 73 65 20 79 6f 75 20 61 72 65 20 62 75 69 6c 64  se you are build
0e30: 69 6e 67 20 4b 69 74 44 4c 4c 27 20 32 3e 26 31  ing KitDLL' 2>&1
0e40: 0a 09 09 09 65 63 68 6f 20 27 20 20 20 20 20 20  ....echo '      
0e50: 20 20 20 53 65 74 20 53 54 41 54 49 43 4d 4b 34     Set STATICMK4
0e60: 20 74 6f 20 6d 61 6b 65 20 74 68 69 73 20 6d 65   to make this me
0e70: 73 73 61 67 65 20 67 6f 20 61 77 61 79 2e 27 20  ssage go away.' 
0e80: 3e 26 32 0a 09 09 09 65 63 68 6f 20 27 20 20 20  >&2....echo '   
0e90: 20 20 20 20 20 20 53 65 74 20 53 54 41 54 49 43        Set STATIC
0ea0: 4d 4b 34 20 74 6f 20 31 20 69 66 20 79 6f 75 20  MK4 to 1 if you 
0eb0: 72 65 61 6c 6c 79 20 77 61 6e 74 20 74 6f 20 6c  really want to l
0ec0: 69 6e 6b 20 4d 6b 34 74 63 6c 20 73 74 61 74 69  ink Mk4tcl stati
0ed0: 63 61 6c 6c 79 20 28 6e 6f 72 6d 61 6c 20 64 65  cally (normal de
0ee0: 66 61 75 6c 74 29 2e 27 20 3e 26 32 0a 09 09 09  fault).' >&2....
0ef0: 65 63 68 6f 20 27 20 20 20 20 20 20 20 20 20 53  echo '         S
0f00: 65 74 20 53 54 41 54 49 43 4d 4b 34 20 74 6f 20  et STATICMK4 to 
0f10: 30 20 74 6f 20 6c 69 6e 6b 20 4d 6b 34 74 63 6c  0 to link Mk4tcl
0f20: 20 64 79 6e 61 6d 69 63 61 6c 6c 79 20 69 66 20   dynamically if 
0f30: 70 6f 73 73 69 62 6c 65 20 28 74 68 69 73 20 69  possible (this i
0f40: 73 20 77 68 61 74 20 69 73 20 68 61 70 70 65 6e  s what is happen
0f50: 69 6e 67 20 6e 6f 77 29 2e 27 20 3e 26 32 0a 09  ing now).' >&2..
0f60: 09 09 65 63 68 6f 20 27 20 20 20 20 20 20 20 20  ..echo '        
0f70: 20 53 65 74 20 53 54 41 54 49 43 4d 4b 34 20 74   Set STATICMK4 t
0f80: 6f 20 2d 31 20 74 6f 20 62 75 69 6c 64 20 64 79  o -1 to build dy
0f90: 6e 61 6d 69 63 61 6c 6c 79 2e 27 20 3e 26 32 0a  namically.' >&2.
0fa0: 0a 09 09 09 53 54 41 54 49 43 4d 4b 34 3d 22 30  ....STATICMK4="0
0fb0: 22 0a 09 09 09 65 78 70 6f 72 74 20 53 54 41 54  "....export STAT
0fc0: 49 43 4d 4b 34 0a 09 09 66 69 0a 09 66 69 0a 66  ICMK4...fi..fi.f
0fd0: 69 0a 0a 23 20 46 69 6e 64 20 57 69 6e 64 6f 77  i..# Find Window
0fe0: 73 20 72 65 73 6f 75 72 63 65 2d 72 65 6c 61 74  s resource-relat
0ff0: 65 64 20 66 69 6c 65 73 0a 69 66 20 5b 20 2d 66  ed files.if [ -f
1000: 20 22 6b 69 74 2e 69 63 6f 22 20 5d 3b 20 74 68   "kit.ico" ]; th
1010: 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 49  en..KITCREATOR_I
1020: 43 4f 4e 3d 22 24 28 70 77 64 29 2f 6b 69 74 2e  CON="$(pwd)/kit.
1030: 69 63 6f 22 0a 65 6c 73 65 0a 09 4b 49 54 43 52  ico".else..KITCR
1040: 45 41 54 4f 52 5f 49 43 4f 4e 3d 22 24 28 65 63  EATOR_ICON="$(ec
1050: 68 6f 20 22 24 28 70 77 64 29 2f 6b 69 74 73 68  ho "$(pwd)/kitsh
1060: 2f 62 75 69 6c 64 73 72 63 22 2f 6b 69 74 73 68  /buildsrc"/kitsh
1070: 2d 2a 2f 74 63 6c 6b 69 74 2e 69 63 6f 29 22 0a  -*/tclkit.ico)".
1080: 66 69 0a 69 66 20 5b 20 2d 66 20 22 6b 69 74 2e  fi.if [ -f "kit.
1090: 72 63 22 20 5d 3b 20 74 68 65 6e 0a 09 4b 49 54  rc" ]; then..KIT
10a0: 43 52 45 41 54 4f 52 5f 52 43 3d 22 24 28 70 77  CREATOR_RC="$(pw
10b0: 64 29 2f 6b 69 74 2e 72 63 22 0a 65 6c 73 65 0a  d)/kit.rc".else.
10c0: 09 4b 49 54 43 52 45 41 54 4f 52 5f 52 43 3d 22  .KITCREATOR_RC="
10d0: 24 28 65 63 68 6f 20 22 24 28 70 77 64 29 2f 6b  $(echo "$(pwd)/k
10e0: 69 74 73 68 2f 62 75 69 6c 64 73 72 63 22 2f 6b  itsh/buildsrc"/k
10f0: 69 74 73 68 2d 2a 2f 6b 69 74 2e 72 63 29 22 0a  itsh-*/kit.rc)".
1100: 66 69 0a 65 78 70 6f 72 74 20 4b 49 54 43 52 45  fi.export KITCRE
1110: 41 54 4f 52 5f 49 43 4f 4e 20 4b 49 54 43 52 45  ATOR_ICON KITCRE
1120: 41 54 4f 52 5f 52 43 0a 0a 23 20 44 65 74 65 72  ATOR_RC..# Deter
1130: 6d 69 6e 65 20 68 6f 77 20 77 65 20 69 6e 76 6f  mine how we invo
1140: 6b 65 20 61 20 54 63 6c 20 69 6e 74 65 72 70 72  ke a Tcl interpr
1150: 65 74 65 72 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  eter.if [ -z "${
1160: 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d 22 20 5d  TCLSH_NATIVE}" ]
1170: 3b 20 74 68 65 6e 0a 09 54 43 4c 53 48 5f 4e 41  ; then..TCLSH_NA
1180: 54 49 56 45 3d 22 66 61 6c 73 65 22 0a 66 69 0a  TIVE="false".fi.
1190: 66 6f 72 20 74 65 73 74 73 68 20 69 6e 20 22 24  for testsh in "$
11a0: 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d 22 20  {TCLSH_NATIVE}" 
11b0: 74 63 6c 73 68 20 74 63 6c 73 68 38 2e 34 20 74  tclsh tclsh8.4 t
11c0: 63 6c 73 68 38 2e 35 20 74 63 6c 73 68 38 2e 36  clsh8.5 tclsh8.6
11d0: 20 22 24 7b 54 43 4c 4b 49 54 3a 2d 74 63 6c 6b   "${TCLKIT:-tclk
11e0: 69 74 7d 22 3b 20 64 6f 0a 09 69 66 20 65 63 68  it}"; do..if ech
11f0: 6f 20 27 65 78 69 74 20 30 27 20 7c 20 22 24 7b  o 'exit 0' | "${
1200: 74 65 73 74 73 68 7d 22 20 3e 2f 64 65 76 2f 6e  testsh}" >/dev/n
1210: 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b  ull 2>/dev/null;
1220: 20 74 68 65 6e 0a 09 09 54 43 4c 53 48 5f 4e 41   then...TCLSH_NA
1230: 54 49 56 45 3d 22 24 7b 74 65 73 74 73 68 7d 22  TIVE="${testsh}"
1240: 0a 0a 09 09 62 72 65 61 6b 0a 09 66 69 0a 64 6f  ....break..fi.do
1250: 6e 65 0a 65 78 70 6f 72 74 20 54 43 4c 53 48 5f  ne.export TCLSH_
1260: 4e 41 54 49 56 45 0a 0a 23 20 46 75 6e 63 74 69  NATIVE..# Functi
1270: 6f 6e 20 74 6f 20 64 65 74 65 72 6d 69 6e 65 20  on to determine 
1280: 77 68 61 74 20 62 75 69 6c 64 20 6d 6f 64 65 20  what build mode 
1290: 69 73 20 62 65 69 6e 67 20 75 73 65 64 0a 66 75  is being used.fu
12a0: 6e 63 74 69 6f 6e 20 75 73 65 43 6f 6d 6d 6f 6e  nction useCommon
12b0: 42 75 69 6c 64 53 79 73 74 65 6d 28 29 20 7b 0a  BuildSystem() {.
12c0: 09 6c 6f 63 61 6c 20 73 63 72 69 70 74 0a 0a 09  .local script...
12d0: 73 63 72 69 70 74 3d 22 24 31 22 0a 0a 09 69 66  script="$1"...if
12e0: 20 67 72 65 70 20 2d 69 20 27 5e 23 20 2a 42 75   grep -i '^# *Bu
12f0: 69 6c 64 43 6f 6d 70 61 74 69 62 6c 65 3a 20 2a  ildCompatible: *
1300: 4b 69 74 43 72 65 61 74 6f 72 20 2a 24 27 20 22  KitCreator *$' "
1310: 24 7b 73 63 72 69 70 74 7d 22 20 3e 2f 64 65 76  ${script}" >/dev
1320: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
1330: 6c 3b 20 74 68 65 6e 0a 09 09 72 65 74 75 72 6e  l; then...return
1340: 20 30 0a 09 66 69 0a 0a 09 72 65 74 75 72 6e 20   0..fi...return 
1350: 31 0a 7d 0a 0a 23 20 43 6c 65 61 6e 75 70 20 62  1.}..# Cleanup b
1360: 75 69 6c 64 20 6c 6f 67 73 0a 66 6f 72 20 70 6b  uild logs.for pk
1370: 67 20 69 6e 20 74 63 6c 20 74 63 6c 76 66 73 20  g in tcl tclvfs 
1380: 7a 6c 69 62 20 24 7b 4b 49 54 43 52 45 41 54 4f  zlib ${KITCREATO
1390: 52 5f 50 4b 47 53 7d 20 6b 69 74 73 68 3b 20 64  R_PKGS} kitsh; d
13a0: 6f 0a 09 72 6d 20 2d 66 20 22 24 7b 70 6b 67 7d  o..rm -f "${pkg}
13b0: 2f 62 75 69 6c 64 2e 6c 6f 67 22 0a 64 6f 6e 65  /build.log".done
13c0: 0a 0a 23 20 56 65 72 69 66 79 20 74 68 61 74 20  ..# Verify that 
13d0: 65 61 63 68 20 63 6f 6d 70 6f 6e 65 6e 74 20 69  each component i
13e0: 73 20 68 61 70 70 79 20 77 69 74 68 20 74 68 65  s happy with the
13f0: 20 65 6e 76 69 72 6f 6e 6d 65 6e 74 0a 76 61 6c   environment.val
1400: 69 64 61 74 65 66 61 69 6c 65 64 3d 22 30 22 0a  idatefailed="0".
1410: 66 6f 72 20 70 6b 67 20 69 6e 20 74 63 6c 20 74  for pkg in tcl t
1420: 63 6c 76 66 73 20 7a 6c 69 62 20 24 7b 4b 49 54  clvfs zlib ${KIT
1430: 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20 6b 69  CREATOR_PKGS} ki
1440: 74 73 68 3b 20 64 6f 0a 09 66 61 69 6c 65 64 3d  tsh; do..failed=
1450: 27 30 27 0a 09 69 66 20 5b 20 2d 66 20 22 24 7b  '0'..if [ -f "${
1460: 70 6b 67 7d 2f 2e 73 75 63 63 65 73 73 22 20 5d  pkg}/.success" ]
1470: 3b 20 74 68 65 6e 0a 09 09 63 6f 6e 74 69 6e 75  ; then...continu
1480: 65 0a 09 66 69 0a 0a 09 69 66 20 5b 20 2d 78 20  e..fi...if [ -x 
1490: 22 24 7b 70 6b 67 7d 2f 76 61 6c 69 64 61 74 65  "${pkg}/validate
14a0: 2e 73 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09 28  .sh" ]; then...(
14b0: 0a 09 09 09 63 64 20 22 24 7b 70 6b 67 7d 22 20  ....cd "${pkg}" 
14c0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
14d0: 76 2f 6e 75 6c 6c 20 7c 7c 20 65 78 69 74 20 31  v/null || exit 1
14e0: 0a 0a 09 09 09 2e 2f 76 61 6c 69 64 61 74 65 2e  ....../validate.
14f0: 73 68 20 33 3e 26 31 20 34 3e 26 32 20 3e 3e 20  sh 3>&1 4>&2 >> 
1500: 62 75 69 6c 64 2e 6c 6f 67 20 32 3e 26 31 20 7c  build.log 2>&1 |
1510: 7c 20 65 78 69 74 20 31 0a 09 09 29 20 7c 7c 20  | exit 1...) || 
1520: 66 61 69 6c 65 64 3d 22 31 22 0a 0a 09 09 69 66  failed="1"....if
1530: 20 5b 20 22 24 7b 66 61 69 6c 65 64 7d 22 20 3d   [ "${failed}" =
1540: 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09   '1' ]; then....
1550: 65 63 68 6f 20 22 46 61 69 6c 65 64 20 70 72 65  echo "Failed pre
1560: 2d 72 65 71 75 69 73 69 74 65 20 63 68 65 63 6b  -requisite check
1570: 20 66 6f 72 20 24 7b 70 6b 67 7d 22 20 3e 26 32   for ${pkg}" >&2
1580: 0a 0a 09 09 09 76 61 6c 69 64 61 74 65 66 61 69  .....validatefai
1590: 6c 65 64 3d 27 31 27 0a 09 09 66 69 0a 09 66 69  led='1'...fi..fi
15a0: 0a 64 6f 6e 65 0a 0a 69 66 20 5b 20 22 24 7b 76  .done..if [ "${v
15b0: 61 6c 69 64 61 74 65 66 61 69 6c 65 64 7d 22 20  alidatefailed}" 
15c0: 3d 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09 65  = '1' ]; then..e
15d0: 78 69 74 20 31 0a 66 69 0a 0a 23 20 44 6f 20 62  xit 1.fi..# Do b
15e0: 75 69 6c 64 0a 66 61 69 6c 65 64 70 6b 67 73 3d  uild.failedpkgs=
15f0: 22 22 0a 62 75 69 6c 64 66 61 69 6c 65 64 3d 22  "".buildfailed="
1600: 30 22 0a 66 6f 72 20 70 6b 67 20 69 6e 20 74 63  0".for pkg in tc
1610: 6c 20 74 63 6c 76 66 73 20 7a 6c 69 62 20 24 7b  l tclvfs zlib ${
1620: 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d  KITCREATOR_PKGS}
1630: 20 6b 69 74 73 68 3b 20 64 6f 0a 09 66 61 69 6c   kitsh; do..fail
1640: 65 64 3d 22 30 22 0a 09 69 66 20 5b 20 2d 66 20  ed="0"..if [ -f 
1650: 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73 73  "${pkg}/.success
1660: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f  " ]; then...echo
1670: 20 2d 6e 20 22 53 6b 69 70 70 69 6e 67 20 24 7b   -n "Skipping ${
1680: 70 6b 67 7d 20 2e 2e 2e 22 0a 09 65 6c 73 65 0a  pkg} ..."..else.
1690: 09 09 65 63 68 6f 20 2d 6e 20 22 42 75 69 6c 64  ..echo -n "Build
16a0: 69 6e 67 20 24 7b 70 6b 67 7d 20 2e 2e 2e 22 0a  ing ${pkg} ...".
16b0: 0a 09 09 28 0a 09 09 09 63 64 20 22 24 7b 70 6b  ...(....cd "${pk
16c0: 67 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  g}" >/dev/null 2
16d0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 65 78  >/dev/null || ex
16e0: 69 74 20 31 0a 0a 09 09 09 62 75 69 6c 64 5f 73  it 1.....build_s
16f0: 63 72 69 70 74 3d 27 2e 2f 62 75 69 6c 64 2e 73  cript='./build.s
1700: 68 27 0a 09 09 09 69 66 20 5b 20 2d 78 20 27 6b  h'....if [ -x 'k
1710: 69 74 63 72 65 61 74 6f 72 2d 62 75 69 6c 64 2e  itcreator-build.
1720: 73 68 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09  sh' ]; then.....
1730: 62 75 69 6c 64 5f 73 63 72 69 70 74 3d 27 2e 2f  build_script='./
1740: 6b 69 74 63 72 65 61 74 6f 72 2d 62 75 69 6c 64  kitcreator-build
1750: 2e 73 68 27 0a 09 09 09 66 69 0a 0a 09 09 09 69  .sh'....fi.....i
1760: 66 20 5b 20 2d 66 20 22 24 7b 62 75 69 6c 64 5f  f [ -f "${build_
1770: 73 63 72 69 70 74 7d 22 20 5d 3b 20 74 68 65 6e  script}" ]; then
1780: 0a 09 09 09 09 62 75 69 6c 64 5f 73 63 72 69 70  .....build_scrip
1790: 74 73 3d 28 22 24 7b 62 75 69 6c 64 5f 73 63 72  ts=("${build_scr
17a0: 69 70 74 7d 22 29 0a 09 09 09 65 6c 73 65 0a 09  ipt}")....else..
17b0: 09 09 09 62 75 69 6c 64 5f 73 63 72 69 70 74 73  ...build_scripts
17c0: 3d 28 24 28 65 63 68 6f 20 62 75 69 6c 64 2d 6b  =($(echo build-k
17d0: 69 74 63 72 65 61 74 6f 72 2d 2a 2e 73 68 29 29  itcreator-*.sh))
17e0: 0a 09 09 09 66 69 0a 0a 09 09 09 63 61 6c 6c 5f  ....fi.....call_
17f0: 70 6b 67 5f 69 6e 69 74 3d 27 31 27 0a 09 09 09  pkg_init='1'....
1800: 66 6f 72 20 62 75 69 6c 64 5f 73 63 72 69 70 74  for build_script
1810: 20 69 6e 20 22 24 7b 62 75 69 6c 64 5f 73 63 72   in "${build_scr
1820: 69 70 74 73 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09  ipts[@]}"; do...
1830: 09 09 69 66 20 75 73 65 43 6f 6d 6d 6f 6e 42 75  ..if useCommonBu
1840: 69 6c 64 53 79 73 74 65 6d 20 22 24 7b 62 75 69  ildSystem "${bui
1850: 6c 64 5f 73 63 72 69 70 74 7d 22 3b 20 74 68 65  ld_script}"; the
1860: 6e 0a 09 09 09 09 09 28 0a 09 09 09 09 09 09 2e  n......(........
1870: 20 2e 2e 2f 63 6f 6d 6d 6f 6e 2f 63 6f 6d 6d 6f   ../common/commo
1880: 6e 2e 73 68 0a 09 09 09 09 09 09 2e 20 22 24 7b  n.sh........ "${
1890: 62 75 69 6c 64 5f 73 63 72 69 70 74 7d 22 0a 0a  build_script}"..
18a0: 09 09 09 09 09 09 73 65 74 20 2d 78 0a 0a 09 09  ......set -x....
18b0: 09 09 09 09 69 66 20 5b 20 22 24 7b 63 61 6c 6c  ....if [ "${call
18c0: 5f 70 6b 67 5f 69 6e 69 74 7d 22 20 3d 20 27 31  _pkg_init}" = '1
18d0: 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 09 09  ' ]; then.......
18e0: 09 69 6e 69 74 20 7c 7c 20 64 69 65 20 27 69 6e  .init || die 'in
18f0: 69 74 20 66 61 69 6c 65 64 27 0a 09 09 09 09 09  it failed'......
1900: 09 66 69 0a 0a 09 09 09 09 09 09 70 72 65 64 6f  .fi........predo
1910: 77 6e 6c 6f 61 64 20 7c 7c 20 64 69 65 20 27 70  wnload || die 'p
1920: 72 65 64 6f 77 6e 6c 6f 61 64 20 66 61 69 6c 65  redownload faile
1930: 64 27 0a 09 09 09 09 09 09 64 6f 77 6e 6c 6f 61  d'.......downloa
1940: 64 20 7c 7c 20 64 69 65 20 27 64 6f 77 6e 6c 6f  d || die 'downlo
1950: 61 64 20 66 61 69 6c 65 64 27 0a 09 09 09 09 09  ad failed'......
1960: 09 70 6f 73 74 64 6f 77 6e 6c 6f 61 64 20 7c 7c  .postdownload ||
1970: 20 64 69 65 20 27 70 6f 73 74 64 6f 77 6e 6c 6f   die 'postdownlo
1980: 61 64 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09  ad failed'......
1990: 09 09 65 78 74 72 61 63 74 20 7c 7c 20 64 69 65  ..extract || die
19a0: 20 27 65 78 74 72 61 63 74 20 66 61 69 6c 65 64   'extract failed
19b0: 27 0a 0a 09 09 09 09 09 09 61 70 70 6c 79 5f 70  '........apply_p
19c0: 61 74 63 68 65 73 20 7c 7c 20 64 69 65 20 27 61  atches || die 'a
19d0: 70 70 6c 79 20 70 61 74 63 68 65 73 20 66 61 69  pply patches fai
19e0: 6c 65 64 27 0a 0a 09 09 09 09 09 09 63 64 20 22  led'........cd "
19f0: 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65  ${workdir}" || e
1a00: 78 69 74 20 31 0a 0a 09 09 09 09 09 09 70 72 65  xit 1........pre
1a10: 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65  configure || die
1a20: 20 27 70 72 65 63 6f 6e 66 69 67 75 72 65 20 66   'preconfigure f
1a30: 61 69 6c 65 64 27 0a 09 09 09 09 09 09 63 6f 6e  ailed'.......con
1a40: 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 63  figure || die 'c
1a50: 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64 27  onfigure failed'
1a60: 0a 09 09 09 09 09 09 70 6f 73 74 63 6f 6e 66 69  .......postconfi
1a70: 67 75 72 65 20 7c 7c 20 64 69 65 20 27 70 6f 73  gure || die 'pos
1a80: 74 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65  tconfigure faile
1a90: 64 27 0a 0a 09 09 09 09 09 09 70 72 65 62 75 69  d'........prebui
1aa0: 6c 64 20 7c 7c 20 64 69 65 20 27 70 72 65 62 75  ld || die 'prebu
1ab0: 69 6c 64 20 66 61 69 6c 65 64 27 0a 09 09 09 09  ild failed'.....
1ac0: 09 09 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  ..build || die '
1ad0: 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 09 09  build failed'...
1ae0: 09 09 09 09 70 6f 73 74 62 75 69 6c 64 20 7c 7c  ....postbuild ||
1af0: 20 64 69 65 20 27 70 6f 73 74 62 75 69 6c 64 20   die 'postbuild 
1b00: 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09 09 70  failed'........p
1b10: 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69 65  reinstall || die
1b20: 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66 61 69   'preinstall fai
1b30: 6c 65 64 27 0a 09 09 09 09 09 09 69 6e 73 74 61  led'.......insta
1b40: 6c 6c 20 7c 7c 20 64 69 65 20 27 69 6e 73 74 61  ll || die 'insta
1b50: 6c 6c 20 66 61 69 6c 65 64 27 0a 09 09 09 09 09  ll failed'......
1b60: 09 70 6f 73 74 69 6e 73 74 61 6c 6c 20 7c 7c 20  .postinstall || 
1b70: 64 69 65 20 27 70 6f 73 74 69 6e 73 74 61 6c 6c  die 'postinstall
1b80: 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09 09   failed'........
1b90: 63 72 65 61 74 65 72 75 6e 74 69 6d 65 20 7c 7c  createruntime ||
1ba0: 20 64 69 65 20 27 63 72 65 61 74 65 72 75 6e 74   die 'createrunt
1bb0: 69 6d 65 20 66 61 69 6c 65 64 27 0a 0a 09 09 09  ime failed'.....
1bc0: 09 09 09 73 65 74 20 2b 78 0a 09 09 09 09 09 29  ...set +x......)
1bd0: 20 33 3e 26 31 20 34 3e 26 32 20 3e 3e 20 62 75   3>&1 4>&2 >> bu
1be0: 69 6c 64 2e 6c 6f 67 20 32 3e 26 31 20 7c 7c 20  ild.log 2>&1 || 
1bf0: 65 78 69 74 20 31 0a 09 09 09 09 65 6c 73 65 0a  exit 1.....else.
1c00: 09 09 09 09 09 22 24 7b 62 75 69 6c 64 5f 73 63  ....."${build_sc
1c10: 72 69 70 74 7d 22 20 33 3e 26 31 20 34 3e 26 32  ript}" 3>&1 4>&2
1c20: 20 3e 3e 20 62 75 69 6c 64 2e 6c 6f 67 20 32 3e   >> build.log 2>
1c30: 26 31 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 09  &1 || exit 1....
1c40: 09 66 69 0a 0a 09 09 09 09 63 61 6c 6c 5f 70 6b  .fi......call_pk
1c50: 67 5f 69 6e 69 74 3d 27 30 27 0a 09 09 09 64 6f  g_init='0'....do
1c60: 6e 65 0a 09 09 29 20 7c 7c 20 66 61 69 6c 65 64  ne...) || failed
1c70: 3d 22 31 22 0a 09 66 69 0a 0a 09 69 66 20 5b 20  ="1"..fi...if [ 
1c80: 22 24 7b 66 61 69 6c 65 64 7d 22 20 3d 20 22 31  "${failed}" = "1
1c90: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f  " ]; then...echo
1ca0: 20 22 20 66 61 69 6c 65 64 2e 22 0a 09 09 66 61   " failed."...fa
1cb0: 69 6c 65 64 70 6b 67 73 3d 22 24 7b 66 61 69 6c  iledpkgs="${fail
1cc0: 65 64 70 6b 67 73 7d 20 24 7b 70 6b 67 7d 22 0a  edpkgs} ${pkg}".
1cd0: 09 65 6c 73 65 0a 09 09 65 63 68 6f 20 22 20 64  .else...echo " d
1ce0: 6f 6e 65 2e 22 0a 09 66 69 0a 0a 09 63 61 73 65  one."..fi...case
1cf0: 20 22 24 7b 70 6b 67 7d 22 20 69 6e 0a 09 09 74   "${pkg}" in...t
1d00: 63 6c 29 0a 09 09 09 54 43 4c 43 4f 4e 46 49 47  cl)....TCLCONFIG
1d10: 44 49 52 3d 24 28 66 69 6e 64 20 22 24 28 70 77  DIR=$(find "$(pw
1d20: 64 29 2f 74 63 6c 2f 62 75 69 6c 64 22 20 2d 6e  d)/tcl/build" -n
1d30: 61 6d 65 20 74 63 6c 43 6f 6e 66 69 67 2e 73 68  ame tclConfig.sh
1d40: 20 7c 20 68 65 61 64 20 2d 31 20 7c 20 73 65 64   | head -1 | sed
1d50: 20 27 73 40 2f 5b 5e 2f 5d 2a 24 40 40 27 29 0a   's@/[^/]*$@@').
1d60: 09 09 09 54 43 4c 43 4f 4e 46 49 47 44 49 52 54  ...TCLCONFIGDIRT
1d70: 41 49 4c 3d 22 24 28 62 61 73 65 6e 61 6d 65 20  AIL="$(basename 
1d80: 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d  "${TCLCONFIGDIR}
1d90: 22 29 22 0a 09 09 09 65 78 70 6f 72 74 20 54 43  ")"....export TC
1da0: 4c 43 4f 4e 46 49 47 44 49 52 20 54 43 4c 43 4f  LCONFIGDIR TCLCO
1db0: 4e 46 49 47 44 49 52 54 41 49 4c 0a 0a 09 09 09  NFIGDIRTAIL.....
1dc0: 23 20 49 66 20 54 63 6c 20 77 61 73 20 63 6f 6d  # If Tcl was com
1dd0: 70 69 6c 65 64 20 77 69 74 68 20 74 68 72 65 61  piled with threa
1de0: 64 73 20 65 6e 61 62 6c 65 64 20 70 61 73 73 20  ds enabled pass 
1df0: 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65 61 64 73  --enable-threads
1e00: 20 74 6f 20 61 6c 6c 20 73 75 62 2d 70 72 6f 6a   to all sub-proj
1e10: 65 63 74 73 0a 09 09 09 69 66 20 5b 20 22 24 7b  ects....if [ "${
1e20: 4b 49 54 43 52 45 41 54 4f 52 5f 41 44 44 5f 45  KITCREATOR_ADD_E
1e30: 4e 41 42 4c 45 5f 54 48 52 45 41 44 53 3a 2d 31  NABLE_THREADS:-1
1e40: 7d 22 20 21 3d 20 27 30 27 20 5d 3b 20 74 68 65  }" != '0' ]; the
1e50: 6e 0a 09 09 09 09 69 66 20 5b 20 22 24 28 20 2e  n.....if [ "$( .
1e60: 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52   "${TCLCONFIGDIR
1e70: 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68 22 20  }/tclConfig.sh" 
1e80: 26 26 20 65 63 68 6f 20 22 24 7b 54 43 4c 5f 54  && echo "${TCL_T
1e90: 48 52 45 41 44 53 3a 2d 30 7d 22 20 29 22 20 3d  HREADS:-0}" )" =
1ea0: 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09   '1' ]; then....
1eb0: 09 09 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41  ..CONFIGUREEXTRA
1ec0: 3d 22 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54  ="${CONFIGUREEXT
1ed0: 52 41 7d 20 2d 2d 65 6e 61 62 6c 65 2d 74 68 72  RA} --enable-thr
1ee0: 65 61 64 73 22 0a 09 09 09 09 66 69 0a 09 09 09  eads".....fi....
1ef0: 66 69 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a  fi....;;..esac..
1f00: 09 69 66 20 5b 20 22 24 7b 66 61 69 6c 65 64 7d  .if [ "${failed}
1f10: 22 20 3d 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a  " = "1" ]; then.
1f20: 09 09 62 75 69 6c 64 66 61 69 6c 65 64 3d 22 31  ..buildfailed="1
1f30: 22 0a 09 65 6c 73 65 0a 09 09 74 6f 75 63 68 20  "..else...touch 
1f40: 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73 73  "${pkg}/.success
1f50: 22 0a 09 66 69 0a 64 6f 6e 65 0a 0a 69 66 20 5b  "..fi.done..if [
1f60: 20 2d 6e 20 22 24 7b 66 61 69 6c 65 64 70 6b 67   -n "${failedpkg
1f70: 73 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68  s}" ]; then..ech
1f80: 6f 20 22 46 61 69 6c 65 64 20 74 6f 20 62 75 69  o "Failed to bui
1f90: 6c 64 3a 24 7b 66 61 69 6c 65 64 70 6b 67 73 7d  ld:${failedpkgs}
1fa0: 22 0a 66 69 0a 0a 69 66 20 5b 20 22 24 7b 62 75  ".fi..if [ "${bu
1fb0: 69 6c 64 66 61 69 6c 65 64 7d 22 20 21 3d 20 22  ildfailed}" != "
1fc0: 30 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f  0" ]; then..echo
1fd0: 20 27 57 41 52 4e 49 4e 47 3a 20 42 75 69 6c 64   'WARNING: Build
1fe0: 20 69 73 20 6c 69 6b 65 6c 79 20 69 6e 63 6f 6d   is likely incom
1ff0: 70 6c 65 74 65 20 6f 72 20 66 61 69 6c 65 64 2e  plete or failed.
2000: 27 20 3e 26 32 0a 66 69 0a 0a 63 70 20 27 6b 69  ' >&2.fi..cp 'ki
2010: 74 73 68 2f 62 75 69 6c 64 27 2f 6b 69 74 73 68  tsh/build'/kitsh
2020: 2d 2a 2f 6c 69 62 74 63 6c 6b 69 74 2a 20 2e 20  -*/libtclkit* . 
2030: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
2040: 76 2f 6e 75 6c 6c 0a 63 70 20 27 6b 69 74 73 68  v/null.cp 'kitsh
2050: 2f 62 75 69 6c 64 27 2f 6b 69 74 73 68 2d 2a 2f  /build'/kitsh-*/
2060: 6b 69 74 20 22 74 63 6c 6b 69 74 2d 24 7b 54 43  kit "tclkit-${TC
2070: 4c 56 45 52 53 7d 22 20 3e 2f 64 65 76 2f 6e 75  LVERS}" >/dev/nu
2080: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 69  ll 2>/dev/null.i
2090: 66 20 5b 20 21 20 2d 66 20 22 74 63 6c 6b 69 74  f [ ! -f "tclkit
20a0: 2d 24 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20  -${TCLVERS}" ]; 
20b0: 74 68 65 6e 0a 09 63 70 20 27 6b 69 74 73 68 2f  then..cp 'kitsh/
20c0: 62 75 69 6c 64 27 2f 6b 69 74 73 68 2d 2a 2f 6b  build'/kitsh-*/k
20d0: 69 74 2e 65 78 65 20 22 74 63 6c 6b 69 74 2d 24  it.exe "tclkit-$
20e0: 7b 54 43 4c 56 45 52 53 7d 22 20 3e 2f 64 65 76  {TCLVERS}" >/dev
20f0: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
2100: 6c 0a 66 69 0a 0a 66 6f 72 20 70 6f 73 74 73 63  l.fi..for postsc
2110: 72 69 70 74 20 69 6e 20 63 6f 6d 6d 6f 6e 2f 70  ript in common/p
2120: 6f 73 74 2f 2a 3b 20 64 6f 0a 09 69 66 20 5b 20  ost/*; do..if [ 
2130: 21 20 2d 66 20 22 24 7b 70 6f 73 74 73 63 72 69  ! -f "${postscri
2140: 70 74 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 63  pt}" ]; then...c
2150: 6f 6e 74 69 6e 75 65 0a 09 66 69 0a 0a 09 22 24  ontinue..fi..."$
2160: 7b 70 6f 73 74 73 63 72 69 70 74 7d 22 0a 64 6f  {postscript}".do
2170: 6e 65 0a 0a 65 78 69 74 20 22 24 7b 62 75 69 6c  ne..exit "${buil
2180: 64 66 61 69 6c 65 64 7d 22 0a                    dfailed}".